// EndSession.cpp: implementation of the CEndSession class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "EndSession.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/* Written by Amir Israeli November 2000,
   You may use this class , modify it , but dont remove this header.
   israelaq@walla.co.il  http://amir-israeli.tripod.com */


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CEndSession::CEndSession()
{
}
CEndSession::~CEndSession()
{
}

BOOL CEndSession::Create()
{
	CWnd *pWnd = AfxGetMainWnd();
	if (!pWnd || !::IsWindow(pWnd->GetSafeHwnd())) return FALSE;
	// hook window and return result (success or not)
	return HookWnd(pWnd);
}

/* These 2 functions has empty implementations of responces to the 
 message WM_ENDSESSION . override this class and override these functions */

/* OnSessionEnding : called when you need to end your app session : this is 
 the place to free all resources , allocated memory , device drivers etc. 
 just the same when OnNewDocument is called (and previous is destroyed) , 
 or when WM_CLOSE/ WM_DESTROY is called and you probably destroy all data. */
void CEndSession::OnSessionEnding()
{
}

/* OnSessionNotEnded: This function is called when finally session
isnt ended and you need to restore all data : in case it was previously 
destroyed as a result of a call of WM_ENDSESSION(TRUE)
here is the place to restore the app (possibly from a stream saved when app unloads)
and reload anything that you unloaded. It is called when some app stoped 
ExitWindows process by FALSE responce to WM_QUERYENDSESSION.  */
void CEndSession::OnSessionNotEnded()
{
}

LRESULT CEndSession::WindowProc2(UINT msg, WPARAM wp, LPARAM lp)
{
	switch (msg)
	{
	/* This message is recieved by application whenever other application calls
	ExitWindows in order to close session: reboot , logoff etc.
	by returning TRUE (yes) you declare that you : this app allows
	end session (it is not so bothered by that). returns FALSE prevents
	(unless its emergency) and stops the process of end session */
	case WM_QUERYENDSESSION:
		return OnPermitEndSession();

	/* Indicates whether session is in process of ending or finally 
	not ended : see the functions for details what to do there */
	case WM_ENDSESSION :
		if ((BOOL)wp)
			OnSessionEnding();		// session is ending
		else  OnSessionNotEnded();	// session not ended
		break;
	}

	// calling base class WindowProc
	return CHook::WindowProc2( msg, wp, lp);
}

